//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string RangeParams = "14,45,55;15,45,55;16,45,55;17,45,55;18,45,55;19,45,55;20,45,55;21,45,55";

//
//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
int    periods[];
double levelsUp[];
double levelsDn[];
int    size;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer2); SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
      
      RangeParams = StringTrimLeft(StringTrimRight(RangeParams));
      if (StringSubstr(RangeParams,StringLen(RangeParams),1) != ";")
                       RangeParams = StringConcatenate(RangeParams,";");

         //
         //
         //
         //
         //                                   
            
         int n,m,s = 0;
         int i = StringFind(RangeParams,";",s);
         while (i > 0)
         {
            string current = StringSubstr(RangeParams,s,i-s);
            if (current!=";")
            {
               size = ArraySize(periods)+1;
                      ArrayResize(periods ,size);
                      ArrayResize(levelsUp,size);
                      ArrayResize(levelsDn,size);
                        n = StringFind(current,",",0); periods[size-1]  = StrToInteger(StringSubstr(current,0,n));  m = n+1;
                        n = StringFind(current,",",m); levelsUp[size-1] = StrToDouble(StringSubstr(current,m,n-m)); m = n+1; 
                                                       levelsDn[size-1] = StrToDouble(StringSubstr(current,m,StringLen(current)-m));
            }
            s = i + 1;
            i = StringFind(RangeParams,";",s);
         }
         
         //
         //
         //
         //
         //
         
   IndicatorShortName("Range oscillator summed "+size);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return (0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      int sum=0;
      for (int k=0; k<size; k++)
      {
         double hhv =  High[ArrayMaximum(High,periods[k],i)];
         double llv =  Low[ ArrayMinimum(Low ,periods[k],i)]; 
         double mpr = (High[i] + Low[i]) / 2.0; 
         double hlr = 0;
            if (hhv!=llv)
                  hlr = 100.0 * (mpr-llv)/(hhv-llv); 
         
            if (hlr > levelsUp[k]) sum += 1;
            if (hlr < levelsDn[k]) sum -= 1;
      }
      buffer0[i] = EMPTY_VALUE;
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
         if (sum== size) { buffer0[i] = 1; continue; }
         if (sum==-size) { buffer1[i] = 1; continue; }
                           buffer2[i] = 1;
   }     
   return(0);
}